#include <bits/stdc++.h>

using namespace std;

std::vector<int> solve(
std::vector<std::pair<int, int>> R,
std::vector<long long> D,
std::vector<int> S,
std::vector<int> T,
std::vector<bool> I
)
{
    bool arr[150001]={};
    for(int i=0;i<S.size();i++)
    {
        if(I[i]==true)
        arr[S[i]]=true;
    }
    vector<int> res;
    for(int i=0;i<S.size();i++)
    {
        if(arr[S[i]]==true)
        {
            res.push_back(T[i]-S[i]+1);
        }
        else
            res.push_back(0);
    }
    return res;
}
